// vue user guide: https://eslint.vuejs.org/user-guide/#usage
// - eslint-plugin-vue requires vue-eslint-parser to parse .vue files
//   - vue-eslint-parser allows us to lint the <template> of .vue files.
//   - but it will override the eslint parser config to vue-eslint-parser
// - use parserOptions.parser property to specify a custom parser to parse <script> tags.
// see https://github.com/mysticatea/vue-eslint-parser#parseroptionsparser

// 用 require.resolve 的方式确保加载的依赖是本地依赖的
// 注意 'plugin:vue/recommended' 的路径变了
module.exports = {
  extends: [require.resolve('eslint-plugin-vue/lib/configs/recommended')],
  parserOptions: {
    // peerDependencies
    parser: 'babel-eslint',
  },
  rules: {
    // 不需要强制 hyphenated, 自己的组件一般用驼峰, 而 vue 官方的比如 transition 是用连字符
    // 这里可以用 never + ignore, 但是这样的话 ignore 的列表以后可能要随着官网组件属性的增加而增加
    // 所以还是禁用掉吧
    'vue/attribute-hyphenation': 0,
  },
};
