const path = require('path');

// modified from @vue/eslint-config-airbnb
// - modified settings import/extensions
module.exports = {
  extends: [require.resolve('eslint-config-airbnb-base')],
  settings: {
    /**
     * copied & modified from @eslint-plugin-import/config/typescript.js
     */
    'import/resolver': {
      [require.resolve('eslint-import-resolver-webpack')]: {
        config: {
          // 配合 eslint-import-resolver-typescript 可以解析 tsconfig "baseUrl" and "paths" 指定的路径, 不用再配 alias 了
          // TODO 但是某些项目没有使用 tsconfig.json 文件, 所以还是要额外定义一遍 alias
          resolve: {
            extensions: ['.js', '.jsx', '.ts', '.tsx', '.vue', '.mjs'],
            alias: {
              src: path.resolve('src'),
              '@': path.resolve('src'),
              $src: path.resolve('src'),
              'agreement/routes': path.resolve('.tmp/routes'),
            },
          },
        },
      },
      // https://github.com/benmosher/eslint-plugin-import/issues/1396
      [require.resolve('eslint-import-resolver-node')]: {
        extensions: ['.js', '.jsx', '.ts', '.tsx', '.vue', '.mjs'],
        // for ts, used with baseUrl set to "."
        paths: ['.'],
      },
      // https://github.com/benmosher/eslint-plugin-import/issues/1485
      // https://github.com/alexgorbatchev/eslint-import-resolver-typescript
      [require.resolve('eslint-import-resolver-typescript')]: {},
    },
    'import/extensions': ['.js', '.jsx', '.ts', '.tsx', '.vue', '.mjs'],
    'import/external-module-folders': ['node_modules', 'node_modules/@types'],
    'import/parsers': {
      [require.resolve('@typescript-eslint/parser')]: ['.ts', '.tsx', '.d.ts'],
    },
  },
  rules: {},
};
