const { rules } = require('eslint-config-airbnb-base/rules/imports');

const ruleKeyNoExtraDeps = 'import/no-extraneous-dependencies';
const ruleNoExtraDeps = rules[ruleKeyNoExtraDeps];
if (
  ruleNoExtraDeps &&
  ruleNoExtraDeps[1] &&
  ruleNoExtraDeps[1].devDependencies
) {
  // 在 Airbnb 的基础上, 这些文件夹里面可以使用 devDependencies
  ruleNoExtraDeps[1].devDependencies.push(
    // 根路径下的 config 文件夹
    '/config/**',
    // 根路径下的 configs 文件夹
    '/configs/**',
    // 根路径下的 script 文件夹
    '/script/**',
    // 根路径下的 scripts 文件夹
    '/scripts/**',
    // 根路径下的 tester 文件夹
    '/tester/**',
    // 根路径下的 stories 文件夹
    '/stories/**',
    '/.storybook/**',
    // 模板
    '/generators/**',
    // 根路径下的 *.js
    '/*.js',
    // 任何路径下的 .*.js
    '**/.*.js',
    // 项目低码组件
    '/src/components/**/lowcode/**',
  );
}

module.exports = {
  settings: {
    // FIXME: 将 webpack alias 作为内部模块, 否则会触发 import/no-extraneous-dependencies 错误
    // 但是如果有更多 alias, 每次都要改这个正则
    // 而且如果有其他 plugin 也定义了这个配置 (虽然目前并没有), 该怎么合并呢
    // 'import/internal-regex': '^@alicd\\/(alias\\/|cone-util)',
  },
  rules: {
    [ruleKeyNoExtraDeps]: ruleNoExtraDeps,
  },
};
